Skip to main content
`Ctrl`+`K`

# Cross compilation

Cross compilation is a complex topic, we only add some hopefully helpful hints here (for now). As of May 2023, cross-compilation based on `crossenv` is known to work, as used (for example) in conda-forge. Cross-compilation without `crossenv` requires some manual overrides. You instruct these overrides by passing options to `meson setup` via meson-python.

All distributions that are known to successfully cross compile SciPy are using `python -m build` (`pypa/build`), but using `pip` for that should be possible as well. Here are links to the SciPy’s “build recipes” on those distros:

- Void Linux

- Nix

- Conda-forge

See also Meson’s documentation on cross compilation to learn what options you may need to pass to Meson to successfully cross compile.

One common hiccup is that `numpy` and `pythran` require running Python code in order to obtain their include directories. This tends to not work well, either accidentally picking up the packages from the build (native) Python rather than the host (cross) Python or requiring `crossenv` or QEMU to run the host Python. To avoid this problem, specify the paths to the relevant directories in your cross file:

    [constants]
    sitepkg = '/abspath/to/host-pythons/site-packages/'

    [properties]
    numpy-include-dir = sitepkg + 'numpy/core/include'
    pythran-include-dir = sitepkg + 'pythran'

For more details and the current status around cross compilation, see:

- Tracking issue for SciPy cross-compilation needs and issues: scipy#14812

- The state of cross compilation in Python: pypackaging-native key issue page